/* perfdata.h - Created by Nick Chan on 11/11/2022 */

#ifndef PERFDATA_PERFDATA_H
#define PERFDATA_PERFDATA_H
#include <stdio.h>
#include <stdint.h>
#include <stddef.h>

#define PDUNIT_CUSTOM(x) "#\"" x "\""

/* not sure about the actual pointer type yet - void* for now */
/* Appearently a pdWriter is at least 0x2b8 bytes in size */
typedef void* pdwriter_t;
/* not sure either */
typedef void* json_t;

/* these being char* have been verified successfully on macOS */
extern char* pdunit_B;
extern char* pdunit_Bps;
extern char* pdunit_CPI;
extern char* pdunit_EB;
extern char* pdunit_EBps;
extern char* pdunit_EFLOPS;
extern char* pdunit_EHz;
extern char* pdunit_EIPS;
extern char* pdunit_EJ;
extern char* pdunit_EW;
extern char* pdunit_EWh;
extern char* pdunit_Eb;
extern char* pdunit_Ebps;
extern char* pdunit_EiB;
extern char* pdunit_EiBps;
extern char* pdunit_Eib;
extern char* pdunit_Eibps;
extern char* pdunit_FLOPS;
extern char* pdunit_FPS;
extern char* pdunit_GB;
extern char* pdunit_GBps;
extern char* pdunit_GFLOPS;
extern char* pdunit_GHz;
extern char* pdunit_GIPS;
extern char* pdunit_GJ;
extern char* pdunit_GW;
extern char* pdunit_GWh;
extern char* pdunit_Gb;
extern char* pdunit_Gbps;
extern char* pdunit_GiB;
extern char* pdunit_GiBps;
extern char* pdunit_Gib;
extern char* pdunit_Gibps;
extern char* pdunit_Hz;
extern char* pdunit_IPC;
extern char* pdunit_IPS;
extern char* pdunit_J;
extern char* pdunit_KiB;
extern char* pdunit_KiBps;
extern char* pdunit_Kib;
extern char* pdunit_Kibps;
extern char* pdunit_MB;
extern char* pdunit_MBps;
extern char* pdunit_MFLOPS;
extern char* pdunit_MHz;
extern char* pdunit_MIPS;
extern char* pdunit_MJ;
extern char* pdunit_MW;
extern char* pdunit_MWh;
extern char* pdunit_Mb;
extern char* pdunit_Mbps;
extern char* pdunit_MiB;
extern char* pdunit_MiBps;
extern char* pdunit_Mib;
extern char* pdunit_Mibps;
extern char* pdunit_PB;
extern char* pdunit_PBps;
extern char* pdunit_PFLOPS;
extern char* pdunit_PHz;
extern char* pdunit_PIPS;
extern char* pdunit_PJ;
extern char* pdunit_PW;
extern char* pdunit_PWh;
extern char* pdunit_Pb;
extern char* pdunit_Pbps;
extern char* pdunit_PiB;
extern char* pdunit_PiBps;
extern char* pdunit_Pib;
extern char* pdunit_Pibps;
extern char* pdunit_TB;
extern char* pdunit_TBps;
extern char* pdunit_TFLOPS;
extern char* pdunit_THz;
extern char* pdunit_TIPS;
extern char* pdunit_TJ;
extern char* pdunit_TW;
extern char* pdunit_TWh;
extern char* pdunit_Tb;
extern char* pdunit_Tbps;
extern char* pdunit_TiB;
extern char* pdunit_TiBps;
extern char* pdunit_Tib;
extern char* pdunit_Tibps;
extern char* pdunit_W;
extern char* pdunit_Wh;
extern char* pdunit_YB;
extern char* pdunit_YBps;
extern char* pdunit_YFLOPS;
extern char* pdunit_YHz;
extern char* pdunit_YIPS;
extern char* pdunit_YJ;
extern char* pdunit_YW;
extern char* pdunit_YWh;
extern char* pdunit_Yb;
extern char* pdunit_Ybps;
extern char* pdunit_YiB;
extern char* pdunit_YiBps;
extern char* pdunit_Yib;
extern char* pdunit_Yibps;
extern char* pdunit_ZB;
extern char* pdunit_ZBps;
extern char* pdunit_ZFLOPS;
extern char* pdunit_ZHz;
extern char* pdunit_ZIPS;
extern char* pdunit_ZJ;
extern char* pdunit_ZW;
extern char* pdunit_ZWh;
extern char* pdunit_Zb;
extern char* pdunit_Zbps;
extern char* pdunit_ZiB;
extern char* pdunit_ZiBps;
extern char* pdunit_Zib;
extern char* pdunit_Zibps;
extern char* pdunit_aHz;
extern char* pdunit_aJ;
extern char* pdunit_aW;
extern char* pdunit_aWh;
extern char* pdunit_as;
extern char* pdunit_asCPU;
extern char* pdunit_attohertz;
extern char* pdunit_attojoules;
extern char* pdunit_attoseconds;
extern char* pdunit_attoseconds_cpu;
extern char* pdunit_attowatt_hours;
extern char* pdunit_attowatts;
extern char* pdunit_b;
extern char* pdunit_bits;
extern char* pdunit_bits_per_second;
extern char* pdunit_bps;
extern char* pdunit_bytes;
extern char* pdunit_bytes_per_second;
extern char* pdunit_cHz;
extern char* pdunit_cJ;
extern char* pdunit_cW;
extern char* pdunit_cWh;
extern char* pdunit_centihertz;
extern char* pdunit_centijoules;
extern char* pdunit_centiseconds;
extern char* pdunit_centiseconds_cpu;
extern char* pdunit_centiwatt_hours;
extern char* pdunit_centiwatts;
extern char* pdunit_cs;
extern char* pdunit_csCPU;
extern char* pdunit_cycles;
extern char* pdunit_cycles_per_instruction;
extern char* pdunit_dHz;
extern char* pdunit_dJ;
extern char* pdunit_dW;
extern char* pdunit_dWh;
extern char* pdunit_daB;
extern char* pdunit_daBps;
extern char* pdunit_daFLOPS;
extern char* pdunit_daHz;
extern char* pdunit_daIPS;
extern char* pdunit_daJ;
extern char* pdunit_daW;
extern char* pdunit_daWh;
extern char* pdunit_dab;
extern char* pdunit_dabps;
extern char* pdunit_decabits;
extern char* pdunit_decabits_per_second;
extern char* pdunit_decabytes;
extern char* pdunit_decabytes_per_second;
extern char* pdunit_decacycles;
extern char* pdunit_decafloating_point_operations_per_second;
extern char* pdunit_decahertz;
extern char* pdunit_decainstructions;
extern char* pdunit_decainstructions_per_second;
extern char* pdunit_decajoules;
extern char* pdunit_decawatt_hours;
extern char* pdunit_decawatts;
extern char* pdunit_decihertz;
extern char* pdunit_decijoules;
extern char* pdunit_deciseconds;
extern char* pdunit_deciseconds_cpu;
extern char* pdunit_deciwatt_hours;
extern char* pdunit_deciwatts;
extern char* pdunit_degrees_celsius;
extern char* pdunit_degrees_fahrenheit;
extern char* pdunit_degrees_kelvin;
extern char* pdunit_ds;
extern char* pdunit_dsCPU;
extern char* pdunit_exabits;
extern char* pdunit_exabits_per_second;
extern char* pdunit_exabytes;
extern char* pdunit_exabytes_per_second;
extern char* pdunit_exacycles;
extern char* pdunit_exafloating_point_operations_per_second;
extern char* pdunit_exahertz;
extern char* pdunit_exainstructions;
extern char* pdunit_exainstructions_per_second;
extern char* pdunit_exajoules;
extern char* pdunit_exawatt_hours;
extern char* pdunit_exawatts;
extern char* pdunit_exbibits;
extern char* pdunit_exbibits_per_second;
extern char* pdunit_exbibytes;
extern char* pdunit_exbibytes_per_second;
extern char* pdunit_fHz;
extern char* pdunit_fJ;
extern char* pdunit_fW;
extern char* pdunit_fWh;
extern char* pdunit_femptohertz;
extern char* pdunit_femptojoules;
extern char* pdunit_femptoseconds;
extern char* pdunit_femptoseconds_cpu;
extern char* pdunit_femptowatt_hours;
extern char* pdunit_femptowatts;
extern char* pdunit_floating_point_operations_per_second;
extern char* pdunit_frames_per_second;
extern char* pdunit_fs;
extern char* pdunit_fsCPU;
extern char* pdunit_gibibits;
extern char* pdunit_gibibits_per_second;
extern char* pdunit_gibibytes;
extern char* pdunit_gibibytes_per_second;
extern char* pdunit_gigabits;
extern char* pdunit_gigabits_per_second;
extern char* pdunit_gigabytes;
extern char* pdunit_gigabytes_per_second;
extern char* pdunit_gigacycles;
extern char* pdunit_gigafloating_point_operations_per_second;
extern char* pdunit_gigahertz;
extern char* pdunit_gigainstructions;
extern char* pdunit_gigainstructions_per_second;
extern char* pdunit_gigajoules;
extern char* pdunit_gigawatt_hours;
extern char* pdunit_gigawatts;
extern char* pdunit_hB;
extern char* pdunit_hBps;
extern char* pdunit_hFLOPS;
extern char* pdunit_hHz;
extern char* pdunit_hIPS;
extern char* pdunit_hJ;
extern char* pdunit_hW;
extern char* pdunit_hWh;
extern char* pdunit_hb;
extern char* pdunit_hbps;
extern char* pdunit_hectobits;
extern char* pdunit_hectobits_per_second;
extern char* pdunit_hectobytes;
extern char* pdunit_hectobytes_per_second;
extern char* pdunit_hectocycles;
extern char* pdunit_hectofloating_point_operations_per_second;
extern char* pdunit_hectohertz;
extern char* pdunit_hectoinstructions;
extern char* pdunit_hectoinstructions_per_second;
extern char* pdunit_hectojoules;
extern char* pdunit_hectowatt_hours;
extern char* pdunit_hectowatts;
extern char* pdunit_hertz;
extern char* pdunit_instructions;
extern char* pdunit_instructions_per_cycle;
extern char* pdunit_instructions_per_second;
extern char* pdunit_joules;
extern char* pdunit_kB;
extern char* pdunit_kBps;
extern char* pdunit_kFLOPS;
extern char* pdunit_kHz;
extern char* pdunit_kIPS;
extern char* pdunit_kJ;
extern char* pdunit_kW;
extern char* pdunit_kWh;
extern char* pdunit_kb;
extern char* pdunit_kbps;
extern char* pdunit_kibibits;
extern char* pdunit_kibibits_per_second;
extern char* pdunit_kibibytes;
extern char* pdunit_kibibytes_per_second;
extern char* pdunit_kilobits;
extern char* pdunit_kilobits_per_second;
extern char* pdunit_kilobytes;
extern char* pdunit_kilobytes_per_second;
extern char* pdunit_kilocycles;
extern char* pdunit_kilofloating_point_operations_per_second;
extern char* pdunit_kilohertz;
extern char* pdunit_kiloinstructions;
extern char* pdunit_kiloinstructions_per_second;
extern char* pdunit_kilojoules;
extern char* pdunit_kilowatt_hours;
extern char* pdunit_kilowatts;
extern char* pdunit_mHz;
extern char* pdunit_mJ;
extern char* pdunit_mW;
extern char* pdunit_mWh;
extern char* pdunit_mebibits;
extern char* pdunit_mebibits_per_second;
extern char* pdunit_mebibytes;
extern char* pdunit_mebibytes_per_second;
extern char* pdunit_megabits;
extern char* pdunit_megabits_per_second;
extern char* pdunit_megabytes;
extern char* pdunit_megabytes_per_second;
extern char* pdunit_megacycles;
extern char* pdunit_megafloating_point_operations_per_second;
extern char* pdunit_megahertz;
extern char* pdunit_megainstructions;
extern char* pdunit_megainstructions_per_second;
extern char* pdunit_megajoules;
extern char* pdunit_megawatt_hours;
extern char* pdunit_megawatts;
extern char* pdunit_microhertz;
extern char* pdunit_microjoules;
extern char* pdunit_microseconds;
extern char* pdunit_microseconds_cpu;
extern char* pdunit_microwatt_hours;
extern char* pdunit_microwatts;
extern char* pdunit_millihertz;
extern char* pdunit_millijoules;
extern char* pdunit_milliseconds;
extern char* pdunit_milliseconds_cpu;
extern char* pdunit_milliwatt_hours;
extern char* pdunit_milliwatts;
extern char* pdunit_ms;
extern char* pdunit_msCPU;
extern char* pdunit_nHz;
extern char* pdunit_nJ;
extern char* pdunit_nW;
extern char* pdunit_nWh;
extern char* pdunit_nanohertz;
extern char* pdunit_nanojoules;
extern char* pdunit_nanoseconds;
extern char* pdunit_nanoseconds_cpu;
extern char* pdunit_nanowatt_hours;
extern char* pdunit_nanowatts;
extern char* pdunit_ns;
extern char* pdunit_nsCPU;
extern char* pdunit_pHz;
extern char* pdunit_pJ;
extern char* pdunit_pW;
extern char* pdunit_pWh;
extern char* pdunit_pebibits;
extern char* pdunit_pebibits_per_second;
extern char* pdunit_pebibytes;
extern char* pdunit_pebibytes_per_second;
extern char* pdunit_percent_cpu;
extern char* pdunit_percent_cpus;
extern char* pdunit_petabits;
extern char* pdunit_petabits_per_second;
extern char* pdunit_petabytes;
extern char* pdunit_petabytes_per_second;
extern char* pdunit_petacycles;
extern char* pdunit_petafloating_point_operations_per_second;
extern char* pdunit_petahertz;
extern char* pdunit_petainstructions;
extern char* pdunit_petainstructions_per_second;
extern char* pdunit_petajoules;
extern char* pdunit_petawatt_hours;
extern char* pdunit_petawatts;
extern char* pdunit_picohertz;
extern char* pdunit_picojoules;
extern char* pdunit_picoseconds;
extern char* pdunit_picoseconds_cpu;
extern char* pdunit_picowatt_hours;
extern char* pdunit_picowatts;
extern char* pdunit_ps;
extern char* pdunit_psCPU;
extern char* pdunit_s;
extern char* pdunit_sCPU;
extern char* pdunit_seconds;
extern char* pdunit_seconds_cpu;
extern char* pdunit_tebibits;
extern char* pdunit_tebibits_per_second;
extern char* pdunit_tebibytes;
extern char* pdunit_tebibytes_per_second;
extern char* pdunit_terabits;
extern char* pdunit_terabits_per_second;
extern char* pdunit_terabytes;
extern char* pdunit_terabytes_per_second;
extern char* pdunit_teracycles;
extern char* pdunit_terafloating_point_operations_per_second;
extern char* pdunit_terahertz;
extern char* pdunit_terainstructions;
extern char* pdunit_terainstructions_per_second;
extern char* pdunit_terajoules;
extern char* pdunit_terawatt_hours;
extern char* pdunit_terawatts;
extern char* pdunit_uHz;
extern char* pdunit_uJ;
extern char* pdunit_uW;
extern char* pdunit_uWh;
extern char* pdunit_us;
extern char* pdunit_usCPU;
extern char* pdunit_watt_hours;
extern char* pdunit_watts;
extern char* pdunit_yHz;
extern char* pdunit_yJ;
extern char* pdunit_yW;
extern char* pdunit_yWh;
extern char* pdunit_yobibits;
extern char* pdunit_yobibits_per_second;
extern char* pdunit_yobibytes;
extern char* pdunit_yobibytes_per_second;
extern char* pdunit_yoctohertz;
extern char* pdunit_yoctojoules;
extern char* pdunit_yoctoseconds;
extern char* pdunit_yoctoseconds_cpu;
extern char* pdunit_yoctowatt_hours;
extern char* pdunit_yoctowatts;
extern char* pdunit_yottabits;
extern char* pdunit_yottabits_per_second;
extern char* pdunit_yottabytes;
extern char* pdunit_yottabytes_per_second;
extern char* pdunit_yottacycles;
extern char* pdunit_yottafloating_point_operations_per_second;
extern char* pdunit_yottahertz;
extern char* pdunit_yottainstructions;
extern char* pdunit_yottainstructions_per_second;
extern char* pdunit_yottajoules;
extern char* pdunit_yottawatt_hours;
extern char* pdunit_yottawatts;
extern char* pdunit_ys;
extern char* pdunit_ysCPU;
extern char* pdunit_zHz;
extern char* pdunit_zJ;
extern char* pdunit_zW;
extern char* pdunit_zWh;
extern char* pdunit_zebibits;
extern char* pdunit_zebibits_per_second;
extern char* pdunit_zebibytes;
extern char* pdunit_zebibytes_per_second;
extern char* pdunit_zeptohertz;
extern char* pdunit_zeptojoules;
extern char* pdunit_zeptoseconds;
extern char* pdunit_zeptoseconds_cpu;
extern char* pdunit_zeptowatt_hours;
extern char* pdunit_zeptowatts;
extern char* pdunit_zettabits;
extern char* pdunit_zettabits_per_second;
extern char* pdunit_zettabytes;
extern char* pdunit_zettabytes_per_second;
extern char* pdunit_zettacycles;
extern char* pdunit_zettafloating_point_operations_per_second;
extern char* pdunit_zettahertz;
extern char* pdunit_zettainstructions;
extern char* pdunit_zettainstructions_per_second;
extern char* pdunit_zettajoules;
extern char* pdunit_zettawatt_hours;
extern char* pdunit_zettawatts;
extern char* pdunit_zs;
extern char* pdunit_zsCPU;

/* end units */

void pdwriter_close(pdwriter_t pdWriter);
void pdwriter_end_extension(pdwriter_t pdWriter, json_t jsonW);
size_t pdwriter_name(char *pdName,char *key,char *recv_buf,size_t recv_buf_size);
void pdwriter_new_group(pdwriter_t pdWriter);
void pdwriter_new_value(pdwriter_t pdWriter, const char* nameBuffer, char* pdUnit, double numd);
pdwriter_t pdwriter_open(const char* pdFile, const char* pdName, uint32_t version, int unused_param_4);
pdwriter_t pdwriter_open_fd(int flides, char* pdName, uint32_t version);
pdwriter_t pdwriter_open_stream(FILE* stream, char* pdName, uint32_t version);
pdwriter_t pdwriter_open_tmp(char *pdName,char *key,uint32_t version,uint32_t unused_param_4,char *str1, uint32_t str1_size);
void pdwriter_record_label_str(pdwriter_t pdWriter, char* label, char* string);
void pdwriter_record_variable_str(pdwriter_t pdWriter, char *key, const char *valueBuf);
void pdwriter_set_description(pdwriter_t pdWriter, char* description);
void pdwriter_set_primary_metric(pdwriter_t pdWriter, char* metric);
uint64_t pdwriter_start_extension(pdwriter_t pdWriter, char* ext_name);

#endif

